<template>
  <transition name="sidebar">
    <div v-click-outside="close" class="modal" v-if="value">
      <div class="modal__top">
        <div v-if="!!$slots.title" class="modal__title">
          <slot name="title" />
        </div>
        <div v-if="!!$slots.description" class="modal__description">
          <slot name="description" />
        </div>
        <div class="modal__body">
          <slot />
          <div v-if="!!$slots.info" class="modal__info">
            <slot name="info" />
          </div>
        </div>
      </div>
      <div v-if="!!$slots.bottom" class="modal__bottom">
        <slot name="bottom" />
      </div>
      <CloseButton @click.native="close" />
    </div>
  </transition>
</template>

<script lang="ts">
import Vue from 'vue'
import { defineComponent, ref } from '@nuxtjs/composition-api'
import CloseButton from './CloseButton.vue'

export default defineComponent<{
  value: boolean
}>({
  name: 'Modal',
  props: ['value'],
  components: { CloseButton },
  setup({ value }, { emit }) {
    const localValue = ref(value || false)
    return {
      localValue,
      close() {
        emit('input', localValue.value)
        Vue.nextTick(() => emit('closed'))
      }
    }
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/variables';

.modal {
  width: 100%;
  position: fixed;
  right: 0px;
  top: 0px;
  bottom: 0;
  z-index: 999;
  background: #272c3b;
  padding: 30px 20px;
  overflow-y: auto;
  overflow-x: hidden;
  display: flex;
  flex-direction: column;
  $self: &;

  @media (min-width: 1199.98px) {
    width: 530px;
    padding: 30px 50px;
  }

  &::-webkit-scrollbar {
    width: 4px;
    height: 4px;
  }
  &::-webkit-scrollbar-track {
    background-color: transparent;
  }
  &::-webkit-scrollbar-thumb {
    background: #00ffb3;
    border-radius: 3px;
  }

  &__top {
    flex: 1;
  }
  &__bottom {
    padding-top: 20px;
  }

  &.menu {
    top: 60px;
    background: #3b435a;
    padding: 30px 50px;
    border-top: 1px solid #272c3b;
    #{ $self }__close {
      top: 15px;
      right: 15px;
      background: 0;
      @media (max-width: 1199.98px) {
        display: none;
      }
    }

    @media (min-width: 1199.98px) {
      width: 425px;
      padding: 60px 70px;
      top: 0px;
      background: #272c3b;
      box-shadow: -1px 3px 37px rgba(#000, 0.15);
      border-top: 0px;
    }
  }

  .close-button {
    top: 23px;
    right: 23px;
    position: absolute;
  }

  &__title {
    text-align: left;
    font-size: 55px;
    line-height: 60px;
    letter-spacing: -1.38px;
    color: #ffffff;
    margin-bottom: 30px;
  }
  &__description {
    font-size: 20px;
    line-height: 25px;
    color: #9badd6;
    margin-bottom: 35px;
    margin-top: -20px;
    &.bold {
      font-weight: bold;
      letter-spacing: 0.9px;
      text-transform: uppercase;
    }
    &.blue {
      color: #0065ff;
    }
  }
  &__info {
    margin-top: 40px;
    font-size: 20px;
    line-height: 25px;
    font-weight: 500;
    color: #7683ad;
  }

  ::v-deep {
    #{ $self }__input {
      padding-top: 10px;
      margin-bottom: 10px;
      position: relative;
      &.is-active {
        #{ $self }__label {
          color: #0065ff;
          font-size: 18px;
          line-height: 18px;
          transform: translateY(5px);
          height: auto;
          z-index: 2;
        }
      }
      *::placeholder {
        opacity: 0;
      }
    }
    #{ $self }__label {
      font-weight: 500;
      font-size: 24px;
      line-height: 30px;
      color: #9badd6;
      position: absolute;
      top: 0px;
      left: 0px;
      right: 0px;
      transform: translateY(11px);
      transition: 0.25s all linear;
      height: 72px;
      display: flex;
      align-items: center;
    }
    #{ $self }__grid {
      display: grid;
      grid-template-columns: 1fr 1fr;
      grid-column-gap: 20px;
    }
  }
}
</style>
